//////////////////////////////////////////////////////////////////////////////////////////
////                                                                                  ////
////                                 Global Variables                                 ////
////                                                                                  ////
//////////////////////////////////////////////////////////////////////////////////////////
extern int MagicNumber=10001;

int Slippage=3;
double MyPoint=Point;
double TheStopLoss=0;
double TheTakeProfit=0;
double lotSize=0.01;
double StopLoss=0;
double TakeProfit=0;
int Step=5;

///////////////////////////////////////////////////////////////////////////////////////////
////                                                                                   ////
////                                   Main Function                                   ////
////                                                                                   ////
///////////////////////////////////////////////////////////////////////////////////////////
int start()
{ 
  if(Digits==3 || Digits==5)
  MyPoint=Point*10;
  
  if(OrdersTotal()==0)
  {
    if(MathRand()%2==0)
    openBuy();
    else
    openSell();
  }
  if(OrdersTotal()==1)
  {
    modifySingleOrder();
    if(OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_BUY)
      {
        if(Bid<=OrderOpenPrice()-Step*MyPoint)
        {
          openSell();
        }
      }
      if(OrderType()==OP_SELL)
      {
        if(Ask>=OrderOpenPrice()+Step*MyPoint)
        {
          openBuy();
        }
      }
    }
  }
  if(OrdersTotal()>1)
  {
    int BuyOrders=0;
    int SellOrders=0;
    for(int i=OrdersTotal()-1; i>=0; i--)
    {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
        if(OrderType()==OP_BUY)
        BuyOrders++;
        else
        SellOrders++;
      }
    }
    if(
        (BuyOrders==SellOrders)/*||
        (
          (HighGreenZone()<Step*MyPoint)&&
          (LowGreenZone()<Step*MyPoint)
        )*/
      )
    {
      cancellAllStopLevels();
      if(Ask>=maxOpenPrice()+Step*MyPoint)
      {
        openBuy();
      }
      if(Bid<=minOpenPrice()-Step*MyPoint)
      {
        openSell();
      }
    }
    if(BuyOrders!=SellOrders)
    {
      if(HighGreenZone()>=Step*MyPoint)
      {
        double HighLimit=maxOpenPrice()+((Step*MyPoint)*3);
        if(Bid>HighLimit && Ask>HighLimit)
        {
          stopAllAtHighGreenZone();
        }
      }
      if(LowGreenZone()>=Step*MyPoint)
      {
        double LowLimit=minOpenPrice()-((Step*MyPoint)*3);
        if(Bid<LowLimit && Ask<LowLimit)
        {
          stopAllAtLowGreenZone();
        }
      }
      if(
          (Ask>=maxOpenPrice()+Step*MyPoint)&&
          (HighGreenZone()<Step*MyPoint)
        )
      
      {
        openBuy();
      }
      if(
          (Bid<=minOpenPrice()-Step*MyPoint)&&
          (LowGreenZone()<Step*MyPoint)
        )
      {
        openSell();
      }
    }
  }
  return true;
}

//////////////////////////////////////////////////////////////////////////////////////////
////                                                                                  ////
////                                 Custom Functions                                 ////
////                                                                                  ////
//////////////////////////////////////////////////////////////////////////////////////////
double maxOpenPrice()
{
  double maxOPP;
  if(OrdersTotal()>0)
  {
    if(OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES))
    {
      maxOPP=OrderOpenPrice();
      for(int i=OrdersTotal()-1; i>=0; i--)
      {
        if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
        {
          maxOPP=MathMax(maxOPP, OrderOpenPrice());
        }
      }
    }
  }
  return maxOPP;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double minOpenPrice()
{
  double minOPP;
  if(OrdersTotal()>0)
  {
    if(OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES))
    {
      minOPP=OrderOpenPrice();
      for(int i=OrdersTotal()-1; i>=0; i--)
      {
        if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
        {
          minOPP=MathMin(minOPP, OrderOpenPrice());
        }
      }
    }
  }
  return minOPP;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double HighGreenZone()
{
  double Total=0;
  double Profit=0;
  for(int l=OrdersTotal()-1; l>=0; l--)
  {
    if(OrderSelect(l, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_BUY)
      {
        if(OrderSelect(l, SELECT_BY_POS, MODE_TRADES))
        {
          Profit=(OrderOpenPrice()-(maxOpenPrice()+Step*MyPoint))*-1;
        }
      }
    }
    if(OrderSelect(l, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_SELL)
      {
        if(OrderSelect(l, SELECT_BY_POS, MODE_TRADES))
        {
          Profit=OrderOpenPrice()-(maxOpenPrice()+Step*MyPoint);
        }
      }
    }
    Total=Total+Profit;
  }
  return Total;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double LowGreenZone()
{
  double Total=0;
  double Profit=0;
  for(int l=OrdersTotal()-1; l>=0; l--)
  {
    if(OrderSelect(l, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_BUY)
      {
        if(OrderSelect(l, SELECT_BY_POS, MODE_TRADES))
        {
          Profit=(OrderOpenPrice()-(minOpenPrice()-Step*MyPoint))*-1;
        }
      }
    }
    if(OrderSelect(l, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_SELL)
      {
        if(OrderSelect(l, SELECT_BY_POS, MODE_TRADES))
        {
          Profit=OrderOpenPrice()-(minOpenPrice()-Step*MyPoint);
        }
      }
    }
    Total=Total+Profit;
  }
  return Total;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int openSell()
{
  if(OrderSend(Symbol(),OP_SELL,lotSize,Bid,Slippage,0,0,"Cool_err",MagicNumber,0,Red))
  return true;
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int openBuy()
{
  if(OrderSend(Symbol(),OP_BUY,lotSize,Ask,Slippage,0,0,"Cool_err",MagicNumber,0,Blue))
  return true;
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int modifySingleOrder()
{
  if(OrdersTotal()==1)
  {
    if(OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderTakeProfit()==0)
      {
        if(OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES))
        {
          if(OrderType()==OP_BUY)
          {
            if(OrderModify(OrderTicket() ,OrderOpenPrice(),NormalizeDouble(0,Digits),NormalizeDouble(maxOpenPrice()+Step*MyPoint,Digits),0,Green))
            return true;
            return true;
          }
        }
        if(OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES))
        {
          if(OrderType()==OP_SELL)
          {
            if(OrderModify(OrderTicket() ,OrderOpenPrice(),NormalizeDouble(0,Digits),NormalizeDouble(minOpenPrice()-Step*MyPoint,Digits),0,Green))
            return true;
          }
        }
      }
    }
  }
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int cancellAllStopLevels()
{
  if(OrdersTotal()>1)
  {
    for(int i=OrdersTotal()-1; i>=0; i--)
    {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
        if(
            (OrderTakeProfit()!=0)||
            (OrderStopLoss()!=0)
          )
        {
          if(OrderModify(OrderTicket() ,OrderOpenPrice(),NormalizeDouble(0,Digits),NormalizeDouble(0,Digits),0,Green))
          return true;
        }
      }
    }
  }
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int stopAllAtHighGreenZone()
{
  for(int i=0; i<OrdersTotal(); i++)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_BUY)
      {
        if(Bid-OrderOpenPrice()>Step*MyPoint)
        {
          if((OrderStopLoss()<Bid-Step*MyPoint) || (OrderStopLoss() == 0))
          {
            if(OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Step*MyPoint,0,0,Green))
            return true;
          }
        }
      }
    }
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_SELL)
      {
        if((Ask-OrderOpenPrice())>(Step*MyPoint))
        {
          if((OrderTakeProfit()<(Ask-Step*MyPoint)) || (OrderTakeProfit()==0))
          {
            if(OrderModify(OrderTicket(),OrderOpenPrice(),0,Ask-Step*MyPoint,0,Red))
            return true;
          }
        }
      }
    }
  }
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int stopAllAtLowGreenZone()
{
  if(OrdersTotal()>1)
  {
    for(int i=0; i<OrdersTotal(); i++)
    {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
        if(OrderType()==OP_BUY)
        {
          if(OrderOpenPrice()-Bid>Step*MyPoint)
          {
            if((OrderTakeProfit()>Bid+Step*MyPoint)||(OrderTakeProfit()==0))
            {
              if(OrderModify(OrderTicket(),OrderOpenPrice(),0,Bid+Step*MyPoint,0,Green))
              return true;
            }
          }
        }
      }
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
        if(OrderType()==OP_SELL)
        {
          if(OrderOpenPrice()-Ask>Step*MyPoint)
          {
            if((OrderStopLoss()>(Ask+Step*MyPoint)) || (OrderStopLoss()==0))
            {
              if(OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Step*MyPoint,0,0,Red))
              return true;
            }
          }
        }
      }
    }
  }
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------